Developer Documentation

Public Slots | Signals | Public Member Functions | Private Slots | Private Member Functions | Private Attributes | List of all members
TopologyPlugin Class Reference
Inheritance diagram for TopologyPlugin:

## Public Slots
QString | version ()

## Signals
void | updateView ()
void | updatedObject (int _id, const UpdateType &_type)
void | addHiddenPickMode (const std::string &_mode)
void | createBackup (int _objectid, QString _name, UpdateType _type=UPDATE_ALL)
void | log (Logtype _type, QString _message)
void | log (QString _message)
void | addToolbar (QToolBar *_toolbar)
Signals inherited from BaseInterface
virtual void | updateView ()
| Update current view in Main Application. More...
virtual void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
| Set a description for a public slot. More...
virtual void | setRenderer (unsigned int _viewer, QString _rendererName)
| Set a renderer for the given viewer. More...
Signals inherited from KeyInterface
virtual void | registerKey (int _key, Qt::KeyboardModifiers _modifiers, QString _description, bool _multiUse=false)
| Register a key-combination for your plugin. More...
Signals inherited from PickingInterface
virtual void | addPickMode (const std::string &_mode)
| Add a new picking mode to the examiner. More...
Signals inherited from BackupInterface
virtual void | createBackup (int _objectid, QString _name, UpdateType _type=UPDATE_ALL)
| Tell Backup Plugin to create a backup. More...
virtual void | aboutToRestore (int _objectid)
| Backup Plugin tells other Plugins that a restore will happen. More...
virtual void | generateBackup (int _id, QString _name, UpdateType _type)
| This signal is emitted by a BackupPlugin and tells a TypePlugin to generate a backup. More...
Signals inherited from LoggingInterface
virtual void | log (Logtype _type, QString _message)=0
virtual void | log (QString _message)=0
Signals inherited from ToolbarInterface
virtual void | addToolbar (QToolBar *_toolbar)
| Adds a Toolbar to the main widget. More...

## Public Member Functions
| TopologyPlugin ()
| Constructor.
| ~TopologyPlugin ()
| Destructor.
QString | name ()
| Return a name for the plugin. More...
QString | description ()
| Return a description of what the plugin is doing. More...

## Private Slots
void | pluginsInitialized ()
| initialize the Plugin More...
void | slotPickModeChanged (const std::string &_mode)
| Toggle actions when the PickMode changes. More...
void | slotMouseEvent (QMouseEvent *_event)
| this is called when a mouse event occurred More...
void | toolBarTriggered (QAction *_action)
| called when an action on the toolbar was triggered More...
Private Slots inherited from BaseInterface
virtual void | exit ()
virtual QString | version ()
| Return a version string for your plugin. More...
Private Slots inherited from KeyInterface
virtual void | slotKeyEvent (QKeyEvent *_event)
| Key Event from Main App. More...

## Private Member Functions
void | clearAddFaceVertices ()
| clear the add face vector More...
void | add_face (QMouseEvent *_event)
| Add a face. More...
void | split_face (QMouseEvent *_event)
| Split a face at the current hit point. More...
void | delete_face (QMouseEvent *_event)
| Delete a face at the current hit point. More...
void | flip_edge (QMouseEvent *_event)
| Flip edge. More...
void | collapse_edge (QMouseEvent *_event)
| Collapse edge. More...
void | split_edge (QMouseEvent *_event)
| Split Edge. More...
Private Member Functions inherited from BaseInterface
virtual void | noguiSupported ()
virtual | ~BaseInterface ()
| Destructor.
virtual void | blockScenegraphUpdates (bool _block)
| Tell the core to prevent scenegraph updates. More...
virtual void | updatedObject (int _objectId)
| An object has been changed or added by this plugin. More...
virtual void | updatedObject (int _identifier, const UpdateType &_type)
| An object has been changed or added by this plugin. More...
virtual void | nodeVisibilityChanged (int _identifier)
| A scenegraph node has been shown or hidden. More...
virtual void | getCurrentRenderer (unsigned int _viewer, QString &_rendererName)
| Get the current renderer for the given viewer. More...
Private Member Functions inherited from MouseInterface
virtual | ~MouseInterface ()
| Destructor.
Private Member Functions inherited from KeyInterface
virtual void | slotKeyReleaseEvent (QKeyEvent *_event)
| Key Release Event from Main App. More...
virtual | ~KeyInterface ()
| Destructor.
Private Member Functions inherited from PickingInterface
virtual void | addHiddenPickMode (const std::string &_mode)
| Add a new picking mode to the examiner which will be invisible. More...
virtual void | setPickModeCursor (const std::string &_mode, QCursor _cursor)
| Set the cursor of the given PickMode. More...
virtual void | setPickModeMouseTracking (const std::string &_mode, bool _mouseTracking)
| Set mouse tracking for the given PickMode. More...
virtual void | setPickModeToolbar (const std::string &_mode, QToolBar *_toolbar)
| Set the additional toolbar of the given PickMode. More...
virtual void | removePickModeToolbar (const std::string &_mode)
| Removes the additional toolbar of the given PickMode. More...
virtual | ~PickingInterface ()
| Destructor.
Private Member Functions inherited from BackupInterface
virtual void | createBackup (IdList _objectids, QString _name, std::vector< UpdateType > _types)
| Tell Backup Plugin to create a group backup. More...
virtual void | undo (int _objectid)
| Tell Backup Plugin to undo the last action of an object. More...
virtual void | redo (int _objectid)
| Tell Backup Plugin to redo the last action on an object. More...
virtual void | undo ()
| Tell Backup Plugin to undo the last action. More...
virtual void | redo ()
| Tell Backup Plugin to redo the last action. More...
virtual | ~BackupInterface ()
| Destructor.
virtual void | restored (int _objectid)
| Backup Plugin tells other Plugins that a restore has happened. More...
Private Member Functions inherited from LoggingInterface
virtual | ~LoggingInterface ()
| Destructor.
Private Member Functions inherited from ToolbarInterface
virtual | ~ToolbarInterface ()
| Destructor.
virtual void | removeToolbar (QToolBar *_toolbar)
| Remove a Toolbar from the main widget. More...
virtual void | getToolBar (QString _name, QToolBar *&_toolbar)
| Get a pointer to a Toolbar of the given name or 0 if it does not exist. More...

## Private Attributes
std::vector< std::pair< int, int > > | addFaceVertices_
QToolBar * | toolbar_
QAction * | edgeFlipAction_
QAction * | edgeSplitAction_
QAction * | edgeCollapseAction_
QAction * | faceAddAction_
QAction * | faceDeleteAction_
QAction * | faceSplitAction_

## Detailed Description

Definition at line 58 of file TopologyPlugin.hh.

## Member Function Documentation

## ◆ add_face()

void TopologyPlugin::add_face | ( | QMouseEvent * | _event | ) |
| private

Add a face.

Parameters

  _event | mouse position where one of the vertices is picked

Todo:
  : Support adding faces between objects ( and merging them into one )

Todo:
  : Support adding faces between objects ( and merging them into one )

Definition at line 236 of file TopologyPlugin.cc.

## ◆ clearAddFaceVertices()

void TopologyPlugin::clearAddFaceVertices | ( |  | ) |
| private

clear the add face vector

Deselect the vertices from AddFace mode.

Definition at line 200 of file TopologyPlugin.cc.

## ◆ collapse_edge()

void TopologyPlugin::collapse_edge | ( | QMouseEvent * | _event | ) |
| private

Collapse edge.

Collapse an edge at the given position.

Parameters

  _event | mouse position where the edge is picked

Definition at line 649 of file TopologyPlugin.cc.

## ◆ delete_face()

void TopologyPlugin::delete_face | ( | QMouseEvent * | _event | ) |
| private

Delete a face at the current hit point.

Delete a face at the given position.

Parameters

  _event | mouse position where the face is picked

Definition at line 535 of file TopologyPlugin.cc.

## ◆ description()

QString TopologyPlugin::description | ( |  | ) |
| inline virtual

Return a description of what the plugin is doing.

This function has to return a basic description of the plugin

Implements BaseInterface.

Definition at line 115 of file TopologyPlugin.hh.

## ◆ flip_edge()

void TopologyPlugin::flip_edge | ( | QMouseEvent * | _event | ) |
| private

Flip edge.

Flip an edge at the given position.

Parameters

  _event | mouse position where the edge is picked

Definition at line 584 of file TopologyPlugin.cc.

## ◆ name()

QString TopologyPlugin::name | ( |  | ) |
| inline virtual

Return a name for the plugin.

This Function has to return the name of the plugin.

Implements BaseInterface.

Definition at line 114 of file TopologyPlugin.hh.

## ◆ pluginsInitialized

void TopologyPlugin::pluginsInitialized | ( |  | ) |
| private slot

initialize the Plugin

Definition at line 73 of file TopologyPlugin.cc.

## ◆ slotMouseEvent

void TopologyPlugin::slotMouseEvent | ( | QMouseEvent * | _event | ) |
| private slot

this is called when a mouse event occurred

Parameters

  _event | the event that occurred

Definition at line 182 of file TopologyPlugin.cc.

## ◆ slotPickModeChanged

void TopologyPlugin::slotPickModeChanged | ( | const std::string & | _mode | ) |
| private slot

Toggle actions when the PickMode changes.

Parameters

  _mode | the new PickMode

Definition at line 166 of file TopologyPlugin.cc.

## ◆ split_edge()

void TopologyPlugin::split_edge | ( | QMouseEvent * | _event | ) |
| private

Split Edge.

Split an edge at the given position.

Parameters

  _event | mouse position where the edge is picked

Definition at line 762 of file TopologyPlugin.cc.

## ◆ split_face()

void TopologyPlugin::split_face | ( | QMouseEvent * | _event | ) |
| private

Split a face at the current hit point.

Split a face at the given point.

Parameters

  _event | mouse position where the face is picked

Definition at line 476 of file TopologyPlugin.cc.

## ◆ toolBarTriggered

void TopologyPlugin::toolBarTriggered | ( | QAction * | _action | ) |
| private slot

called when an action on the toolbar was triggered

Toolbar action was triggered.

Parameters

  _action | the action that was triggered

Definition at line 142 of file TopologyPlugin.cc.

The documentation for this class was generated from the following files:

- Plugin-Topology/TopologyPlugin.hh
- Plugin-Topology/TopologyPlugin.cc